searchNodes=[{"doc":"Exposes the queryable behaviour and utility macro for making Ecto Query composition for Ecto Schemas easier to define, isolate, and be consistent.","ref":"EctoUtils.Queryable.html","title":"EctoUtils.Queryable","type":"behaviour"},{"doc":"Generic fallback filters for the EctoUtils.Queryable behaviour. Schemas which implement the query/2 callback are able to add a catch-all fallback clause pointing to this function in order to allow EctoUtils to automatically derive common queries.Usage:@impl EctoUtils.Queryable def query(base_query \\ base_query(), filters) do Enum.reduce(filters, query, fn {:inserted_at_start, datetime}, query -&gt; from(x in query, where: x.inserted_at &gt;= ^datetime) {:inserted_at_end, datetime}, query -&gt; from(x in query, where: x.inserted_at &lt;= ^datetime) {:updated_at_start, datetime}, query -&gt; from(x in query, where: x.updated_at &gt;= ^datetime) {:updated_at_end, datetime}, query -&gt; from(x in query, where: x.updated_at &lt;= ^datetime) {field, value}, query -&gt; apply_filter(query, field, value) end) end","ref":"EctoUtils.Queryable.html#apply_filter/3","title":"EctoUtils.Queryable.apply_filter/3","type":"function"},{"doc":"","ref":"EctoUtils.Queryable.html#c:base_query/0","title":"EctoUtils.Queryable.base_query/0","type":"callback"},{"doc":"Returns true if, and only if, the given module implements the EctoUtils.Queryable behaviour","ref":"EctoUtils.Queryable.html#implemented_by?/1","title":"EctoUtils.Queryable.implemented_by?/1","type":"function"},{"doc":"","ref":"EctoUtils.Queryable.html#c:query/2","title":"EctoUtils.Queryable.query/2","type":"callback"},{"doc":"Utility module containing functions which aim to augment modules that use Ecto.Repo","ref":"EctoUtils.Repo.html","title":"EctoUtils.Repo","type":"module"},{"doc":"Allows you to execute any EctoUtils.Repo function in the module that use-es this macro.This is useful for centralizing Repo functions in your app's own repo module, rather than you needing to manually call EctoUtils.Repo functions yourself.Usage:defmodule MyApp.Repo do use Ecto.Repo, ... use EctoUtils.Repo end MyApp.Repo.schema?(Date.utc_today()) &gt; false","ref":"EctoUtils.Repo.html#__using__/1","title":"EctoUtils.Repo.__using__/1","type":"macro"},{"doc":"Executes the given closure in a transaction; returning its returns, but ensuring that the transaction was rolled back in the process.","ref":"EctoUtils.Repo.html#dry_run/2","title":"EctoUtils.Repo.dry_run/2","type":"function"},{"doc":"Given a struct derived from a module that use-es Ecto.Schema, returns the list of currently preloaded associations for said schema.This can be useful when used in conjunction with Repo.reload/2 to refetch a given struct from the database while also reloading all preloads:user = %MyApp.User{orgs: [...]} preloads = MyApp.Repo.preloads(user) user |&gt; MyApp.Repo.reload() |&gt; MyApp.Repo.preload(preloads)","ref":"EctoUtils.Repo.html#preloads/1","title":"EctoUtils.Repo.preloads/1","type":"function"},{"doc":"Returns true if the given paramter is an Elixir module that use-es Ecto.Schema or is a struct derived from a module that use-es Ecto.Schema","ref":"EctoUtils.Repo.html#schema?/1","title":"EctoUtils.Repo.schema?/1","type":"function"},{"doc":"Utility module containing functions which aim to augment modules that use Ecto.Schema","ref":"EctoUtils.Schema.html","title":"EctoUtils.Schema","type":"module"},{"doc":"Allows you to execute any EctoUtils.Schema function in the module that use-es this macro.This is useful for building a custom MyApp.Schema module that you use rather than the default Ecto.Schema, allowing for convenient extension capabilities, building off of EctoUtils's extended base functionality.Usage:defmodule MyApp.Schema do use Ecto.Schema use EctoUtils.Schema, repo: MyApp.Repo end","ref":"EctoUtils.Schema.html#__using__/1","title":"EctoUtils.Schema.__using__/1","type":"macro"},{"doc":"Ecto sanitizes inputs passed in via attrs such that trying to cast a field to nil will be determined to be a no-op and will silently fail.This function lets you explicitly mark fields where nil casts are valid, and will perform them for you.Use as follows:def changeset(%MyApp.User{} = struct, attrs) do struct |&gt; cast([:is_deleted]) |&gt; mark_nilable(params, :is_deleted) end # When called as `changeset(%MyApp.User{is_deleted: true}, %{is_deleted: nil}})`, will return # a changeset containing the `is_deleted: nil` change, where without using this function, # no change would be detected.","ref":"EctoUtils.Schema.html#mark_nilable/3","title":"EctoUtils.Schema.mark_nilable/3","type":"function"},{"doc":"Helper function for handling the boilerplate of preloading associations before setting them as an association, particularly useful for many-to-many or has-many relations.","ref":"EctoUtils.Schema.html#preload_put_assoc/5","title":"EctoUtils.Schema.preload_put_assoc/5","type":"function"}]